Index: /palm/trunk/SOURCE/land_surface_model_mod.f90
===================================================================
--- /palm/trunk/SOURCE/land_surface_model_mod.f90	(revision 2269)
+++ /palm/trunk/SOURCE/land_surface_model_mod.f90	(revision 2270)
@@ -1890,19 +1980,12 @@
           tt_soil_v_m(l)%var_2d    = 0.0_wp
           tm_soil_v_m(l)%var_2d    = 0.0_wp
-          tm_liq_eb_v_m(l)%var_1d  = 0.0_wp
+          tm_liq_v_m(l)%var_1d  = 0.0_wp
           surf_lsm_v(l)%c_liq = 0.0_wp
 
-          surf_lsm_v(l)%ghf_eb = 0.0_wp
-          surf_lsm_v(l)%shf_eb = rho_cp * surf_lsm_v(l)%shf
-
-          IF ( humidity )  THEN
-             surf_lsm_v(l)%qsws_eb = rho_lv * surf_lsm_v(l)%qsws
-          ELSE
-             surf_lsm_v(l)%qsws_eb = 0.0_wp
-          ENDIF
-
-          surf_lsm_v(l)%qsws_liq_eb  = 0.0_wp
-          surf_lsm_v(l)%qsws_soil_eb = 0.0_wp
-          surf_lsm_v(l)%qsws_veg_eb  = 0.0_wp
+          surf_lsm_v(l)%ghf = 0.0_wp
+
+          surf_lsm_v(l)%qsws_liq  = 0.0_wp
+          surf_lsm_v(l)%qsws_soil = 0.0_wp
+          surf_lsm_v(l)%qsws_veg  = 0.0_wp
 
           surf_lsm_v(l)%r_a        = 50.0_wp
@@ -1911,14 +1994,21 @@
           surf_lsm_v(l)%r_soil     = 0.0_wp
        ENDDO
-
-        
+   
 !
 !--    Allocate 3D soil model arrays
 !--    First, for horizontal surfaces
+       ALLOCATE ( surf_lsm_h%alpha_vg(nzb_soil:nzt_soil,1:surf_lsm_h%ns)    )
+       ALLOCATE ( surf_lsm_h%gamma_w_sat(nzb_soil:nzt_soil,1:surf_lsm_h%ns) )
+       ALLOCATE ( surf_lsm_h%lambda_h(nzb_soil:nzt_soil,1:surf_lsm_h%ns)    )
+       ALLOCATE ( surf_lsm_h%l_vg(nzb_soil:nzt_soil,1:surf_lsm_h%ns)        )
+       ALLOCATE ( surf_lsm_h%m_fc(nzb_soil:nzt_soil,1:surf_lsm_h%ns)        )
+       ALLOCATE ( surf_lsm_h%m_res(nzb_soil:nzt_soil,1:surf_lsm_h%ns)       )
+       ALLOCATE ( surf_lsm_h%m_sat(nzb_soil:nzt_soil,1:surf_lsm_h%ns)       )
+       ALLOCATE ( surf_lsm_h%m_wilt(nzb_soil:nzt_soil,1:surf_lsm_h%ns)      )
+       ALLOCATE ( surf_lsm_h%n_vg(nzb_soil:nzt_soil,1:surf_lsm_h%ns)        )
+       ALLOCATE ( surf_lsm_h%rho_c_total(nzb_soil:nzt_soil,1:surf_lsm_h%ns) )
        ALLOCATE ( surf_lsm_h%root_fr(nzb_soil:nzt_soil,1:surf_lsm_h%ns)     )
-       ALLOCATE ( surf_lsm_h%lambda_h(nzb_soil:nzt_soil,1:surf_lsm_h%ns)    )
-       ALLOCATE ( surf_lsm_h%rho_c_total(nzb_soil:nzt_soil,1:surf_lsm_h%ns) )
-
-       surf_lsm_h%lambda_h = 0.0_wp
+    
+       surf_lsm_h%lambda_h     = 0.0_wp
 !
 !--    If required, allocate humidity-related variables for the soil model
@@ -1932,9 +2022,18 @@
 !--    For vertical surfaces
        DO  l = 0, 3
+          ALLOCATE ( surf_lsm_v(l)%alpha_vg(nzb_soil:nzt_soil,1:surf_lsm_v(l)%ns)    )
+          ALLOCATE ( surf_lsm_v(l)%gamma_w_sat(nzb_soil:nzt_soil,1:surf_lsm_v(l)%ns) )
+          ALLOCATE ( surf_lsm_v(l)%lambda_h(nzb_soil:nzt_soil,1:surf_lsm_v(l)%ns)    )
+          ALLOCATE ( surf_lsm_v(l)%l_vg(nzb_soil:nzt_soil,1:surf_lsm_v(l)%ns)        )
+          ALLOCATE ( surf_lsm_v(l)%m_fc(nzb_soil:nzt_soil,1:surf_lsm_v(l)%ns)        )
+          ALLOCATE ( surf_lsm_v(l)%m_res(nzb_soil:nzt_soil,1:surf_lsm_v(l)%ns)       )
+          ALLOCATE ( surf_lsm_v(l)%m_sat(nzb_soil:nzt_soil,1:surf_lsm_v(l)%ns)       )
+          ALLOCATE ( surf_lsm_v(l)%m_wilt(nzb_soil:nzt_soil,1:surf_lsm_v(l)%ns)      )
+          ALLOCATE ( surf_lsm_v(l)%n_vg(nzb_soil:nzt_soil,1:surf_lsm_v(l)%ns)        )
+          ALLOCATE ( surf_lsm_v(l)%rho_c_total(nzb_soil:nzt_soil,1:surf_lsm_v(l)%ns) )  
           ALLOCATE ( surf_lsm_v(l)%root_fr(nzb_soil:nzt_soil,1:surf_lsm_v(l)%ns)     )
-          ALLOCATE ( surf_lsm_v(l)%lambda_h(nzb_soil:nzt_soil,1:surf_lsm_v(l)%ns)    )
-          ALLOCATE ( surf_lsm_v(l)%rho_c_total(nzb_soil:nzt_soil,1:surf_lsm_v(l)%ns) )
-
-          surf_lsm_v(l)%lambda_h = 0.0_wp
+
+          surf_lsm_v(l)%lambda_h     = 0.0_wp 
+          
 !
 !--       If required, allocate humidity-related variables for the soil model
@@ -1949,21 +2048,76 @@
 !
 !--    Calculate grid spacings. Temperature and moisture are defined at
-!--    the edges of the soil layers (_stag), whereas gradients/fluxes are defined
-!--    at the centers
-       dz_soil(nzb_soil) = zs(nzb_soil)
-
+!--    the center of the soil layers, whereas gradients/fluxes are 
+!--    defined at the edges (_layer)
+       DO  k = nzb_soil, nzt_soil-1
+          dz_soil(k) = zs(k+1) - zs(k)
+          
+          IF ( dz_soil(k) == 0.0_wp )  THEN
+             message_string = 'invalid soil layer configuration found ' //     &
+                              '(dz_soil(k) = 0.0)'
+             CALL message( 'lsm_read_restart_data', 'PA0140', 1, 2, 0, 6, 0 )
+          ENDIF
+          
+       ENDDO
+
+       dz_soil_layer(nzb_soil) = 2.0_wp * zs(nzb_soil)
+       zs_layer(nzb_soil)      = 2.0_wp * zs(nzb_soil)
+
+
+       
+       
        DO  k = nzb_soil+1, nzt_soil
-          dz_soil(k) = zs(k) - zs(k-1)
+          dz_soil_layer(k) = ( zs(k) - zs_layer(k-1) ) * 2.0_wp
+          zs_layer(k) = zs_layer(k-1) + dz_soil_layer(k)
        ENDDO
-       dz_soil(nzt_soil+1) = dz_soil(nzt_soil)
-
-       DO  k = nzb_soil, nzt_soil-1
-          dz_soil_stag(k) = 0.5_wp * (dz_soil(k+1) + dz_soil(k))
+       dz_soil_layer(nzt_soil+1) = 0.5_wp * dz_soil_layer(nzt_soil)
+       dz_soil(nzt_soil) = zs_layer(k-1) + dz_soil_layer(k) - zs(nzt_soil)
+
+       
+       ddz_soil       = 1.0_wp / dz_soil
+       ddz_soil_layer = 1.0_wp / dz_soil_layer
+
+
+!
+!--    Set flag parameter for the prescribed surface type depending on user 
+!--    input.
+       DO  m = 1, surf_lsm_h%ns
+
+          SELECT CASE ( TRIM( surface_type ) )
+          
+             CASE ( 'vegetation' )
+         
+                surf_lsm_h%vegetation_surface(m)    = .TRUE.
+   
+             CASE ( 'water' )
+             
+                surf_lsm_h%water_surface(m)      = .TRUE.
+
+             CASE ( 'pavement' )
+             
+                surf_lsm_h%pavement_surface(m)   = .TRUE.
+    
+          END SELECT
+  
        ENDDO
-       dz_soil_stag(nzt_soil) = dz_soil(nzt_soil)
-
-       ddz_soil      = 1.0_wp / dz_soil
-       ddz_soil_stag = 1.0_wp / dz_soil_stag
-
+       
+       DO  l = 0, 3
+          SELECT CASE ( TRIM( surface_type ) )
+          
+             CASE ( 'vegetation' )
+         
+                surf_lsm_v(l)%vegetation_surface = .TRUE.
+   
+             CASE ( 'water' )
+
+                surf_lsm_v(l)%water_surface   = .TRUE.
+
+             CASE ( 'pavement' )
+             
+                surf_lsm_h%pavement_surface   = .TRUE.
+
+          END SELECT   
+
+       ENDDO
 !
 !--    Initialize standard soil types. It is possible to overwrite each
@@ -1989,23 +2143,119 @@
 
           IF ( saturation_moisture == 9999999.9_wp )  THEN
-             saturation_moisture = m_soil_pars(0,soil_type)           
+             saturation_moisture = soil_pars(4,soil_type)           
           ENDIF
 
           IF ( field_capacity == 9999999.9_wp )  THEN
-             field_capacity = m_soil_pars(1,soil_type)           
+             field_capacity = soil_pars(5,soil_type)           
           ENDIF
 
           IF ( wilting_point == 9999999.9_wp )  THEN
-             wilting_point = m_soil_pars(2,soil_type)            
+             wilting_point = soil_pars(6,soil_type)            
           ENDIF
 
           IF ( residual_moisture == 9999999.9_wp )  THEN
-             residual_moisture = m_soil_pars(3,soil_type)       
+             residual_moisture = soil_pars(7,soil_type)       
           ENDIF
 
        ENDIF    
-
-!
-!--    Map values to the respective 2D arrays
+  
+!
+!--    Check whether parameters from the lookup tables are to be used
+       IF ( vegetation_type /= 0 )  THEN
+
+          IF ( min_canopy_resistance == 9999999.9_wp )  THEN
+             min_canopy_resistance = vegetation_pars(0,vegetation_type)
+          ENDIF
+
+          IF ( leaf_area_index == 9999999.9_wp )  THEN
+             leaf_area_index = vegetation_pars(1,vegetation_type)         
+          ENDIF
+
+          IF ( vegetation_coverage == 9999999.9_wp )  THEN
+             vegetation_coverage = vegetation_pars(2,vegetation_type)     
+          ENDIF
+
+          IF ( canopy_resistance_coefficient == 9999999.9_wp )  THEN
+              canopy_resistance_coefficient= vegetation_pars(3,vegetation_type)     
+          ENDIF
+
+          IF ( z0_vegetation == 9999999.9_wp )  THEN
+             z0_vegetation  = vegetation_pars(4,vegetation_type) 
+          ENDIF
+
+          IF ( z0h_vegetation == 9999999.9_wp )  THEN
+             z0h_vegetation = vegetation_pars(5,vegetation_type)
+          ENDIF   
+          
+!
+!--       The heat conductivity between canopy and first soil layer must
+!--       depend on the depth of the soil layer. The value in the lookup
+!--       table refers to the first soil temperature at zs = -0.005 m. Lambda 
+!--       is thus interpolated to the actual soil layer depth used.
+          IF ( lambda_surface_stable == 9999999.9_wp )  THEN
+             lambda_surface_stable = vegetation_pars(6,vegetation_type)        &
+                                     * 0.005_wp * ddz_soil_layer(nzb_soil)     &
+                                     * 2.0_wp    
+          ENDIF
+
+          IF ( lambda_surface_unstable == 9999999.9_wp )  THEN
+             lambda_surface_unstable = vegetation_pars(7,vegetation_type)      &
+                                       * 0.005_wp  * ddz_soil_layer(nzb_soil)  &
+                                       * 2.0_wp             
+          ENDIF
+
+          IF ( f_shortwave_incoming == 9999999.9_wp )  THEN
+             f_shortwave_incoming = vegetation_pars(8,vegetation_type)        
+          ENDIF
+
+          IF ( c_surface == 9999999.9_wp )  THEN
+             c_surface = vegetation_pars(9,vegetation_type)        
+          ENDIF
+              
+       ENDIF
+
+       IF ( water_type /= 0 )  THEN
+
+          IF ( water_temperature == 9999999.9_wp )  THEN
+             water_temperature = water_pars(0,water_type)       
+          ENDIF
+
+          IF ( z0_water == 9999999.9_wp )  THEN
+             z0_water = water_pars(1,water_type)       
+          ENDIF       
+
+          IF ( z0h_water == 9999999.9_wp )  THEN
+             z0h_water = water_pars(2,water_type)       
+          ENDIF  
+
+       ENDIF 
+       
+       IF ( pavement_type /= 0 )  THEN  
+
+          IF ( pavement_depth == 9999999.9_wp )  THEN
+             pavement_depth = pavement_pars(0,pavement_type)
+          ELSE
+             pavement_depth = MAX( zs(nzb_soil), pavement_depth )
+          ENDIF
+
+          IF ( z0_pavement == 9999999.9_wp )  THEN
+             z0_pavement  = pavement_pars(1,pavement_type) 
+          ENDIF
+
+          IF ( z0h_pavement == 9999999.9_wp )  THEN
+             z0h_pavement = pavement_pars(2,pavement_type)
+          ENDIF
+
+          IF ( pavement_heat_conduct == 9999999.9_wp )  THEN
+             pavement_heat_conduct = pavement_pars(3,pavement_type)
+          ENDIF
+
+          IF ( pavement_heat_capacity == 9999999.9_wp )  THEN
+             pavement_heat_capacity = pavement_pars(4,pavement_type)
+          ENDIF   
+    
+       ENDIF
+!
+!--    Map values to the respective 2D/3D arrays
 !--    Horizontal surfaces
        surf_lsm_h%alpha_vg      = alpha_vangenuchten
@@ -2032,6 +2282,4 @@
        ENDDO
 
-
-
 !
 !--    Initial run actions
@@ -2039,32 +2287,79 @@
 !
 !--       First, for horizontal surfaces
-          t_soil_h%var_2d    = 0.0_wp
-          m_soil_h%var_2d    = 0.0_wp
-          m_liq_eb_h%var_1d  = 0.0_wp
-
-!
-!--       Map user settings of T and q for each soil layer
-!--       (make sure that the soil moisture does not drop below the permanent
-!--       wilting point) -> problems with devision by zero)
-          DO  k = nzb_soil, nzt_soil
-             t_soil_h%var_2d(k,:)      = soil_temperature(k)
-             m_soil_h%var_2d(k,:)      = MAX(soil_moisture(k),surf_lsm_h%m_wilt(:))
-             soil_moisture(k) = MAX(soil_moisture(k),wilting_point)
-          ENDDO
-          t_soil_h%var_2d(nzt_soil+1,:) = soil_temperature(nzt_soil+1)
-
-!
-!--       Calculate surface temperature
-          t_surface_h%var_1d(:)    = pt_surface * exn
-          surf_lsm_h%pt_surface(:) = pt_surface
-
 !
 !--       Set artifical values for ts and us so that r_a has its initial value 
 !--       for the first time step. Only for interior core domain, not for ghost points
           DO  m = 1, surf_lsm_h%ns
+
+             t_soil_h%var_2d(:,m)    = 0.0_wp
+             m_soil_h%var_2d(:,m)    = 0.0_wp
+             m_liq_h%var_1d(m)       = 0.0_wp
+
+!--          Map user settings of T and q for each soil layer
+!--          (make sure that the soil moisture does not drop below the permanent
+!--          wilting point) -> problems with devision by zero)
+             IF ( surf_lsm_h%water_surface(m) )  THEN
+
+                surf_lsm_h%z0(m)          = z0_water
+                surf_lsm_h%z0h(m)         = z0h_water
+                surf_lsm_h%z0q(m)         = z0h_water
+                t_soil_h%var_2d(:,m)      = water_temperature
+                surf_lsm_h%lambda_surface_s(m) = 1.0E10_wp
+                surf_lsm_h%lambda_surface_u(m) = 1.0E10_wp               
+                surf_lsm_h%c_surface(m)        = 0.0_wp
+                
+             ELSEIF ( surf_lsm_h%pavement_surface(m) )  THEN
+
+                surf_lsm_h%z0(m)          = z0_pavement
+                surf_lsm_h%z0h(m)         = z0h_pavement
+                surf_lsm_h%z0q(m)         = z0h_pavement   
+                DO  k = nzb_soil, nzt_soil  
+                   t_soil_h%var_2d(k,m)   = soil_temperature(k)
+                   m_soil_h%var_2d(k,m)   = MAX(soil_moisture(k),surf_lsm_h%m_wilt(k,m))
+                   soil_moisture(k)       = MAX(soil_moisture(k),wilting_point)           
+                ENDDO
+                t_soil_h%var_2d(nzt_soil+1,m) = soil_temperature(nzt_soil+1)
+                surf_lsm_h%lambda_surface_s(m) = pavement_heat_conduct         &
+                                                 * ddz_soil_layer(nzb_soil)    &
+                                                 * 2.0_wp
+                surf_lsm_h%lambda_surface_u(m) = surf_lsm_h%lambda_surface_s(m)                                         
+                surf_lsm_h%c_surface(m)        = pavement_heat_capacity        &
+                                                 * dz_soil_layer(nzb_soil)     &
+                                                 * 0.25_wp
+                surf_lsm_h%lambda_h_def(m)    = pavement_heat_conduct                                     
+                surf_lsm_h%rho_c_def(m)       = pavement_heat_capacity                                                
+                
+             ELSEIF ( surf_lsm_h%vegetation_surface(m) )  THEN
+
+                surf_lsm_h%z0(m)          = z0_vegetation
+                surf_lsm_h%z0h(m)         = z0h_vegetation
+                surf_lsm_h%z0q(m)         = z0h_vegetation   
+                DO  k = nzb_soil, nzt_soil                        
+                   t_soil_h%var_2d(k,m)   = soil_temperature(k)
+                   m_soil_h%var_2d(k,m)   = MAX(soil_moisture(k),surf_lsm_h%m_wilt(k,m))
+                   soil_moisture(k)       = MAX(soil_moisture(k),wilting_point)         
+                ENDDO 
+                t_soil_h%var_2d(nzt_soil+1,m) = soil_temperature(nzt_soil+1)
+                surf_lsm_h%lambda_surface_s(m) = lambda_surface_stable
+                surf_lsm_h%lambda_surface_u(m) = lambda_surface_unstable
+                surf_lsm_h%c_surface(m)        = c_surface
+
+             ENDIF
+ 
              i   = surf_lsm_h%i(m)            
              j   = surf_lsm_h%j(m)
              k   = surf_lsm_h%k(m)
-
+!
+!--          Calculate surface temperature. In case of bare soil, the surface 
+!--          temperature must be reset to the soil temperature in the first soil 
+!--          layer
+             IF ( surf_lsm_h%lambda_surface_s(m) == 0.0_wp )  THEN
+                t_surface_h%var_1d(:)    = t_soil_h%var_2d(nzb_soil,m)
+                surf_lsm_h%pt_surface(:) = t_soil_h%var_2d(nzb_soil,m) / exn
+             ELSE
+                t_surface_h%var_1d(:)    = pt_surface * exn
+                surf_lsm_h%pt_surface(:) = pt_surface  
+             ENDIF
+             
              IF ( cloud_physics )  THEN
                 pt1 = pt(k,j,i) + l_d_cp * pt_d_t(k) * ql(k,j,i)
@@ -2079,34 +2374,82 @@
              surf_lsm_h%us(m)   = 0.1_wp
              surf_lsm_h%ts(m)   = ( pt1 - surf_lsm_h%pt_surface(m) ) / surf_lsm_h%r_a(m)
-             surf_lsm_h%shf(m)  = - surf_lsm_h%us(m) * surf_lsm_h%ts(m)
-          ENDDO
-!
-!--       Vertical surfaces
-          DO  l = 0, 3
-
-             t_soil_v(l)%var_2d    = 0.0_wp
-             m_soil_v(l)%var_2d    = 0.0_wp
-             m_liq_eb_v(l)%var_1d  = 0.0_wp
-
-!
-!--          Map user settings of T and q for each soil layer
-!--          (make sure that the soil moisture does not drop below the permanent
-!--          wilting point) -> problems with devision by zero)
-             DO  k = nzb_soil, nzt_soil
-                t_soil_v(l)%var_2d(k,:)      = soil_temperature(k)
-                m_soil_v(l)%var_2d(k,:)      = MAX(soil_moisture(k),surf_lsm_v(l)%m_wilt(:))
-                soil_moisture(k) = MAX(soil_moisture(k),wilting_point)
-             ENDDO
-             t_soil_v(l)%var_2d(nzt_soil+1,:) = soil_temperature(nzt_soil+1)
-
-!
-!--          Calculate surface temperature
-             t_surface_v(l)%var_1d(:)   = pt_surface * exn
-             surf_lsm_h%pt_surface(:)   = pt_surface
-
-!
-!--          Set artifical values for ts and us so that r_a has its initial value 
-!--          for the first time step. Only for interior core domain, not for ghost points
+             surf_lsm_h%shf(m)  = - surf_lsm_h%us(m) * surf_lsm_h%ts(m) * rho_surface
+
+         ENDDO
+
+!
+!--      Vertical surfaces
+         DO  l = 0, 3
              DO  m = 1, surf_lsm_v(l)%ns
+             
+                t_soil_v(l)%var_2d    = 0.0_wp
+                m_soil_v(l)%var_2d    = 0.0_wp
+                m_liq_v(l)%var_1d  = 0.0_wp
+
+             
+!--             Map user settings of T and q for each soil layer
+!--             (make sure that the soil moisture does not drop below the permanent
+!--             wilting point) -> problems with devision by zero)
+                IF ( surf_lsm_v(l)%water_surface(m) )  THEN
+                   surf_lsm_v(l)%z0(m)          = z0_water
+                   surf_lsm_v(l)%z0h(m)         = z0h_water 
+                   surf_lsm_v(l)%z0q(m)         = z0h_water                   
+                   t_soil_v(l)%var_2d(:,m)      = water_temperature
+                   surf_lsm_v(l)%lambda_surface_s(m) = 1.0E10_wp
+                   surf_lsm_v(l)%lambda_surface_u(m) = 1.0E10_wp             
+                   surf_lsm_v(l)%c_surface(m)        = 0.0_wp
+                   
+                ELSEIF ( surf_lsm_v(l)%pavement_surface(m) )  THEN
+                   surf_lsm_v(l)%z0(m)          = z0_pavement
+                   surf_lsm_v(l)%z0h(m)         = z0h_pavement
+                   surf_lsm_v(l)%z0q(m)         = z0h_pavement  
+                   DO  k = nzb_soil, nzt_soil  
+                      t_soil_v(l)%var_2d(k,m)      = soil_temperature(k)
+                      m_soil_v(l)%var_2d(k,m)   = MAX(soil_moisture(k),surf_lsm_v(l)%m_wilt(k,m))
+                      soil_moisture(k)          = MAX(soil_moisture(k),wilting_point)   
+                   ENDDO
+                   t_soil_v(l)%var_2d(nzt_soil+1,m)  = soil_temperature(nzt_soil+1)
+                   surf_lsm_v(l)%lambda_surface_s(m) = pavement_heat_conduct      &
+                                                       * ddz_soil_layer(nzb_soil) &
+                                                       * 2.0_wp
+                   surf_lsm_v(l)%lambda_surface_u(m) = surf_lsm_v(l)%lambda_surface_s(m)
+                   surf_lsm_v(l)%c_surface(m) = pavement_heat_capacity         &
+                                                * dz_soil_layer(nzb_soil)      &
+                                                * 0.25_wp
+                   surf_lsm_v(l)%lambda_h_def(m)   = pavement_heat_conduct                                     
+                   surf_lsm_v(l)%rho_c_def(m)      = pavement_heat_capacity                           
+                   
+                ELSEIF ( surf_lsm_v(l)%vegetation_surface(m) )  THEN
+
+                   surf_lsm_v(l)%z0(m)          = z0_vegetation
+                   surf_lsm_v(l)%z0h(m)         = z0h_vegetation
+                   surf_lsm_v(l)%z0q(m)         = z0h_vegetation   
+                   DO  k = nzb_soil, nzt_soil                        
+                      t_soil_v(l)%var_2d(k,m)   = soil_temperature(k)
+                      m_soil_v(l)%var_2d(k,m)   = MAX(soil_moisture(k),surf_lsm_v(l)%m_wilt(k,m))
+                      soil_moisture(k)          = MAX(soil_moisture(k),wilting_point)         
+                   ENDDO 
+                   t_soil_v(l)%var_2d(nzt_soil+1,m) = soil_temperature(nzt_soil+1)
+                   surf_lsm_v(l)%lambda_surface_s(m) = lambda_surface_stable
+                   surf_lsm_v(l)%lambda_surface_u(m) = lambda_surface_unstable
+                   surf_lsm_v(l)%c_surface(m)        = c_surface
+                ENDIF        
+         
+!
+!--             Calculate surface temperature. In case of bare soil, the surface 
+!--             temperature must be reset to the soil temperature in the first soil 
+!--             layer
+                IF ( surf_lsm_v(l)%lambda_surface_s(m) == 0.0_wp )  THEN
+                   t_surface_v(l)%var_1d(:)      = t_soil_v(l)%var_2d(nzb_soil,m)
+                   surf_lsm_v(l)%pt_surface(:)   = t_soil_v(l)%var_2d(nzb_soil,m) / exn
+                ELSE
+                   t_surface_v(l)%var_1d(:)      = pt_surface * exn
+                   surf_lsm_v(l)%pt_surface(:)   = pt_surface               
+                ENDIF
+
+!
+!--             Set artifical values for ts and us so that r_a has its initial value 
+!--             for the first time step. Only for interior core domain, not for ghost points
+
                 i   = surf_lsm_v(l)%i(m)            
                 j   = surf_lsm_v(l)%j(m)
@@ -2121,9 +2464,9 @@
 !
 !--             Assure that r_a cannot be zero at model start
-                IF ( pt1 == surf_lsm_h%pt_surface(m) )  pt1 = pt1 + 1.0E-10_wp
+                IF ( pt1 == surf_lsm_v(l)%pt_surface(m) )  pt1 = pt1 + 1.0E-10_wp
 
                 surf_lsm_v(l)%us(m)   = 0.1_wp
-                surf_lsm_v(l)%ts(m)   = ( pt1 - surf_lsm_h%pt_surface(m) ) / surf_lsm_v(l)%r_a(m)
-                surf_lsm_v(l)%shf(m)  = - surf_lsm_v(l)%us(m) * surf_lsm_v(l)%ts(m)
+                surf_lsm_v(l)%ts(m)   = ( pt1 - surf_lsm_v(l)%pt_surface(m) ) / surf_lsm_v(l)%r_a(m)
+                surf_lsm_v(l)%shf(m)  = - surf_lsm_v(l)%us(m) * surf_lsm_v(l)%ts(m) * rho_surface
              ENDDO
           ENDDO
@@ -2191,93 +2534,29 @@
        ENDDO
 
-       IF ( veg_type /= 0 )  THEN
-          IF ( min_canopy_resistance == 9999999.9_wp )  THEN
-             min_canopy_resistance = veg_pars(0,veg_type)
-          ENDIF
-          IF ( leaf_area_index == 9999999.9_wp )  THEN
-             leaf_area_index = veg_pars(1,veg_type)         
-          ENDIF
-          IF ( vegetation_coverage == 9999999.9_wp )  THEN
-             vegetation_coverage = veg_pars(2,veg_type)     
-          ENDIF
-          IF ( canopy_resistance_coefficient == 9999999.9_wp )  THEN
-              canopy_resistance_coefficient= veg_pars(3,veg_type)     
-          ENDIF
-          IF ( lambda_surface_stable == 9999999.9_wp )  THEN
-             lambda_surface_stable = surface_pars(0,veg_type)         
-          ENDIF
-          IF ( lambda_surface_unstable == 9999999.9_wp )  THEN
-             lambda_surface_unstable = surface_pars(1,veg_type)        
-          ENDIF
-          IF ( f_shortwave_incoming == 9999999.9_wp )  THEN
-             f_shortwave_incoming = surface_pars(2,veg_type)        
-          ENDIF
-          IF ( z0_eb == 9999999.9_wp )  THEN
-             roughness_length = roughness_par(0,veg_type) 
-             z0_eb            = roughness_par(0,veg_type) 
-          ENDIF
-          IF ( z0h_eb == 9999999.9_wp )  THEN
-             z0h_eb = roughness_par(1,veg_type)
-          ENDIF
-          IF ( z0q_eb == 9999999.9_wp )  THEN
-             z0q_eb = roughness_par(2,veg_type)
-          ENDIF
-          z0h_factor = z0h_eb / ( z0_eb + 1.0E-20_wp )
-
-          IF ( ALL( root_fraction == 9999999.9_wp ) )  THEN
-             DO  m = 1, surf_lsm_h%ns
-                i   = surf_lsm_h%i(m)            
-                j   = surf_lsm_h%j(m)
-
-
-                DO  k = nzb_soil, nzt_soil 
-                   surf_lsm_h%root_fr(k,m) = root_distribution(k,veg_type)
-                   root_fraction(k)        = root_distribution(k,veg_type)
+
+
+       IF ( ALL( root_fraction == 9999999.9_wp ) )  THEN
+          DO  m = 1, surf_lsm_h%ns
+             i   = surf_lsm_h%i(m)            
+             j   = surf_lsm_h%j(m)
+
+
+             DO  k = nzb_soil, nzt_soil 
+                surf_lsm_h%root_fr(k,m) = root_distribution(k,vegetation_type)
+                root_fraction(k)        = root_distribution(k,vegetation_type)
+             ENDDO
+          ENDDO
+          DO  l = 0, 3
+             DO  m = 1, surf_lsm_v(l)%ns
+                i   = surf_lsm_v(l)%i(m)            
+                j   = surf_lsm_v(l)%j(m)
+
+                DO  k = nzb_soil, nzt_soil
+                   surf_lsm_v(l)%root_fr(k,m) = root_distribution(k,vegetation_type)
+                   root_fraction(k)           = root_distribution(k,vegetation_type)
                 ENDDO
              ENDDO
-             DO  l = 0, 3
-                DO  m = 1, surf_lsm_v(l)%ns
-                   i   = surf_lsm_v(l)%i(m)            
-                   j   = surf_lsm_v(l)%j(m)
-
-                   DO  k = nzb_soil, nzt_soil
-                      surf_lsm_v(l)%root_fr(k,m) = root_distribution(k,veg_type)
-                      root_fraction(k)    = root_distribution(k,veg_type)
-                   ENDDO
-                ENDDO
-             ENDDO
-          ENDIF
-
-       ELSE
-
-          IF ( z0_eb == 9999999.9_wp )  THEN
-             z0_eb = roughness_length
-          ENDIF
-          IF ( z0h_eb == 9999999.9_wp )  THEN
-             z0h_eb = z0_eb * z0h_factor
-          ENDIF
-          IF ( z0q_eb == 9999999.9_wp )  THEN
-             z0q_eb = z0_eb * z0h_factor
-          ENDIF
-
-       ENDIF
-
-!
-!--    For surfaces covered with pavement, set depth of the pavement (with dry
-!--    soil below). The depth must be greater than the first soil layer depth
-       IF ( veg_type == 20 )  THEN
-          IF ( pave_depth == 9999999.9_wp )  THEN
-             pave_depth = zs(nzb_soil)  
-          ELSE
-             pave_depth = MAX( zs(nzb_soil), pave_depth )
-          ENDIF
-       ENDIF
-
-!
-!--    Map vegetation and soil types to 2D array to allow for heterogeneous 
-!--    surfaces via user interface see below
-!--    First for horizontal surfaces
-       surf_lsm_h%veg_type_2d  = veg_type
-       surf_lsm_h%soil_type_2d = soil_type
+           ENDDO
+       ENDIF
 
 !
@@ -2287,15 +2566,8 @@
        surf_lsm_h%c_veg             = vegetation_coverage
        surf_lsm_h%g_d               = canopy_resistance_coefficient
-       surf_lsm_h%lambda_surface_s  = lambda_surface_stable
-       surf_lsm_h%lambda_surface_u  = lambda_surface_unstable
        surf_lsm_h%f_sw_in           = f_shortwave_incoming
-       surf_lsm_h%z0                = z0_eb
-       surf_lsm_h%z0h               = z0h_eb
-       surf_lsm_h%z0q               = z0q_eb
 
 !--    Vertical surfaces
        DO  l = 0, 3
-          surf_lsm_v(l)%veg_type_2d  = veg_type
-          surf_lsm_v(l)%soil_type_2d = soil_type
 
 !
@@ -2305,34 +2577,11 @@
           surf_lsm_v(l)%c_veg             = vegetation_coverage
           surf_lsm_v(l)%g_d               = canopy_resistance_coefficient
-          surf_lsm_v(l)%lambda_surface_s  = lambda_surface_stable
-          surf_lsm_v(l)%lambda_surface_u  = lambda_surface_unstable
           surf_lsm_v(l)%f_sw_in           = f_shortwave_incoming
-          surf_lsm_v(l)%z0                = z0_eb
-          surf_lsm_v(l)%z0h               = z0h_eb
-          surf_lsm_v(l)%z0q               = z0q_eb
        ENDDO
-
+ 
 !
 !--    Possibly do user-defined actions (e.g. define heterogeneous land surface)
        CALL user_init_land_surface
 
-!
-!--    Set flag parameter if vegetation type was set to a water surface. Also
-!--    set temperature to a constant value in all "soil" layers.
-!--    For now, do not set water surface for vertical surfaces
-       DO  m = 1, surf_lsm_h%ns
-          i   = surf_lsm_h%i(m)            
-          j   = surf_lsm_h%j(m)
-
-          IF ( surf_lsm_h%veg_type_2d(m) == 14  .OR.                           &
-               surf_lsm_h%veg_type_2d(m) == 15 )  THEN
-             surf_lsm_h%water_surface(m) = .TRUE.
-             t_soil_h%var_2d(:,m) = t_surface_h%var_1d(m)
-          ELSEIF ( surf_lsm_h%veg_type_2d(m) == 20 )  THEN
-             surf_lsm_h%pave_surface(m) = .TRUE.
-             m_soil_h%var_2d(:,m)            = 0.0_wp
-          ENDIF
-
-       ENDDO
 
 !
@@ -2343,10 +2592,10 @@
        t_soil_h_p    = t_soil_h
        m_soil_h_p    = m_soil_h
-       m_liq_eb_h_p  = m_liq_eb_h
+       m_liq_h_p  = m_liq_h
        t_surface_h_p = t_surface_h
 
        t_soil_v_p    = t_soil_v
        m_soil_v_p    = m_soil_v
-       m_liq_eb_v_p  = m_liq_eb_v
+       m_liq_v_p  = m_liq_v
        t_surface_v_p = t_surface_v
 
@@ -2377,8 +2626,8 @@
 !
 !--    Allocate global 1D arrays
-       ALLOCATE ( ddz_soil(nzb_soil:nzt_soil+1) )
-       ALLOCATE ( ddz_soil_stag(nzb_soil:nzt_soil) )
-       ALLOCATE ( dz_soil(nzb_soil:nzt_soil+1) )
-       ALLOCATE ( dz_soil_stag(nzb_soil:nzt_soil) )
+       ALLOCATE ( ddz_soil(nzb_soil:nzt_soil) )
+       ALLOCATE ( ddz_soil_layer(nzb_soil:nzt_soil+1) )
+       ALLOCATE ( dz_soil(nzb_soil:nzt_soil) )
+       ALLOCATE ( dz_soil_layer(nzb_soil:nzt_soil+1) )
        ALLOCATE ( root_extr(nzb_soil:nzt_soil) )
   
@@ -2393,6 +2642,6 @@
 !
 !--    Horizontal surfaces
-       ALLOCATE ( m_liq_eb_h%var_1d(1:surf_lsm_h%ns)                     )
-       ALLOCATE ( m_liq_eb_h_p%var_1d(1:surf_lsm_h%ns)                   )
+       ALLOCATE ( m_liq_h%var_1d(1:surf_lsm_h%ns)                     )
+       ALLOCATE ( m_liq_h_p%var_1d(1:surf_lsm_h%ns)                   )
        ALLOCATE ( t_surface_h%var_1d(1:surf_lsm_h%ns)                    )
        ALLOCATE ( t_surface_h_p%var_1d(1:surf_lsm_h%ns)                  )
@@ -2401,9 +2650,10 @@
        ALLOCATE ( t_soil_h%var_2d(nzb_soil:nzt_soil+1,1:surf_lsm_h%ns)   )
        ALLOCATE ( t_soil_h_p%var_2d(nzb_soil:nzt_soil+1,1:surf_lsm_h%ns) )
+
 !
 !--    Vertical surfaces
        DO  l = 0, 3
-          ALLOCATE ( m_liq_eb_v(l)%var_1d(1:surf_lsm_v(l)%ns)                     )
-          ALLOCATE ( m_liq_eb_v(l)_p%var_1d(1:surf_lsm_v(l)%ns)                   )
+          ALLOCATE ( m_liq_v(l)%var_1d(1:surf_lsm_v(l)%ns)                     )
+          ALLOCATE ( m_liq_v(l)_p%var_1d(1:surf_lsm_v(l)%ns)                   )
           ALLOCATE ( t_surface_v(l)%var_1d(1:surf_lsm_v(l)%ns)                    )
           ALLOCATE ( t_surface_v(l)_p%var_1d(1:surf_lsm_v(l)%ns)                  )
